# newgrf_station.h File Reference

Header file for NewGRF stations. More...

`#include "engine.h"`
`#include "newgrf_callbacks.h"`
`#include "newgrf_cargo.h"`
`#include "tile_type.h"`
`#include "strings_type.h"`

Go to the source code of this file.

## Data Structures
struct | EnumPropsT< StationClassID >
| Define basic enum properties. More...
struct | StationSpec
struct | StationClass
| Struct containing information relating to station classes. More...
## Typedefs
typedef TinyEnumT< StationClassID > | StationClassIDByte
typedef byte * | StationLayout
## Enumerations
enum | StationClassID { STAT_CLASS_BEGIN = 0, STAT_CLASS_DFLT = 0, STAT_CLASS_WAYP, STAT_CLASS_MAX = 32 }
## Functions
| DECLARE_POSTFIX_INCREMENT (StationClassID)
| Allow incrementing of StationClassID variables.
void | ResetStationClasses ()
| Reset station classes to their default state.
StationClassID | AllocateStationClass (uint32 cls)
| Allocate a station class for the given class id.
void | SetStationClassName (StationClassID sclass, StringID name)
| Set the name of a custom station class.
StringID | GetStationClassName (StationClassID sclass)
| Retrieve the name of a custom station class.
uint | GetNumStationClasses ()
| Get the number of station classes in use.
uint | GetNumCustomStations (StationClassID sclass)
| Return the number of stations for the given station class.
void | SetCustomStationSpec (StationSpec *statspec)
| Tie a station spec to its station class.
const StationSpec * | GetCustomStationSpec (StationClassID sclass, uint station)
| Retrieve a station spec from a class.
const StationSpec * | GetCustomStationSpecByGrf (uint32 grfid, byte localidx)
uint32 | GetPlatformInfo (Axis axis, byte tile, int platforms, int length, int x, int y, bool centred)
SpriteID | GetCustomStationRelocation (const StationSpec *statspec, const Station *st, TileIndex tile)
SpriteID | GetCustomStationGroundRelocation (const StationSpec *statspec, const Station *st, TileIndex tile)
uint16 | GetStationCallback (CallbackID callback, uint32 param1, uint32 param2, const StationSpec *statspec, const Station *st, TileIndex tile)
bool | IsStationTileBlocked (TileIndex tile)
bool | IsStationTileElectrifiable (TileIndex tile)
int | AllocateSpecToStation (const StationSpec *statspec, Station *st, bool exec)
| Allocate a StationSpec to a Station.
void | DeallocateSpecFromStation (Station *st, byte specindex)
| Deallocate a StationSpec from a Station.
bool | DrawStationTile (int x, int y, RailType railtype, Axis axis, StationClassID sclass, uint station)
| Draw representation of a station tile for GUI purposes.

## Detailed Description

Header file for NewGRF stations.

Definition in file newgrf_station.h.

## Enumeration Type Documentation

enum StationClassID

Enumerator:

  STAT_CLASS_BEGIN | the lowest valid value
  STAT_CLASS_DFLT | Default station class.
  STAT_CLASS_WAYP | Waypoint class.
  STAT_CLASS_MAX | Maximum number of classes.

Definition at line 14 of file newgrf_station.h.

## Function Documentation

int AllocateSpecToStation | ( | const StationSpec * | statspec,
|  | Station * | st,
|  | bool | exec |
| ) |  |  |

Allocate a StationSpec to a Station.

This is called once per build operation.

Parameters:

  | statspec | StationSpec to allocate.
  | st | Station to allocate it to.
  | exec | Whether to actually allocate the spec.

Returns:
  Index within the Station's spec list, or -1 if the allocation failed.

Definition at line 672 of file newgrf_station.cpp.

References ReallocT().

Referenced by CmdBuildRailroadStation().

StationClassID AllocateStationClass | ( | uint32 | cls | ) |

Allocate a station class for the given class id.

Parameters:

  | cls | A 32 bit value identifying the class.

Returns:
  Index into _station_classes of allocated class.

Definition at line 71 of file newgrf_station.cpp.

References grfmsg(), StationClass::id, STAT_CLASS_BEGIN, STAT_CLASS_DFLT, and STAT_CLASS_MAX.

void DeallocateSpecFromStation | ( | Station * | st,
|  | byte | specindex |
| ) |  |  |

Deallocate a StationSpec from a Station.

Called when removing a single station tile.

Parameters:

  | st | Station to work with.
  | specindex | Index of the custom station within the Station's spec list.

Returns:
  Indicates whether the StationSpec was deallocated.

Definition at line 716 of file newgrf_station.cpp.

References BEGIN_TILE_LOOP, END_TILE_LOOP, IsTileType(), MP_STATION, and ReallocT().

Referenced by CmdRemoveFromRailroadStation().

bool DrawStationTile | ( | int | x,
|  | int | y,
|  | RailType | railtype,
|  | Axis | axis,
|  | StationClassID | sclass,
|  | uint | station |
| ) |  |  |

Draw representation of a station tile for GUI purposes.

Parameters:

  | x | Position x of image.
  | y | Position y of image.
  | axis | Axis.
  | railtype | Rail type.
  | sclass,station | Type of station.
  | station | station ID

Returns:
  True if the tile was drawn (allows for fallback to default graphic)

Definition at line 756 of file newgrf_station.cpp.

References CALLBACK_FAILED, CBID_STATION_SPRITE_LAYOUT, CBM_STATION_SPRITE_LAYOUT, RailtypeInfo::custom_ground_offset, foreach_draw_tile_seq, GetCustomStationSpec(), GetRailTypeInfo(), HasBit(), INVALID_TILE, PALETTE_MODIFIER_COLOR, PALETTE_MODIFIER_TRANSPARENT, and RailtypeInfo::total_offset.

Referenced by DrawWaypointSprite().

const StationSpec* GetCustomStationSpec | ( | StationClassID | sclass,
|  | uint | station |
| ) |  |  |

Retrieve a station spec from a class.

Parameters:

  | sclass | Index of the station class.
  | station | The station index with the class.

Returns:
  The station spec.

Definition at line 152 of file newgrf_station.cpp.

References StationClass::spec, and STAT_CLASS_MAX.

Referenced by AfterLoadWaypoints(), CmdBuildRailroadStation(), CmdBuildTrainWaypoint(), and DrawStationTile().

uint GetNumCustomStations | ( | StationClassID | sclass | ) |

Return the number of stations for the given station class.

Parameters:

  | sclass | Index of the station class.

Returns:
  Number of stations in the class.

Definition at line 118 of file newgrf_station.cpp.

References STAT_CLASS_MAX, and StationClass::stations.

Referenced by AfterLoadWaypoints(), and CmdBuildTrainWaypoint().

uint GetNumStationClasses | ( |  | ) |

Get the number of station classes in use.

Returns:
  Number of station classes.

Definition at line 106 of file newgrf_station.cpp.

References StationClass::id, and STAT_CLASS_MAX.

Referenced by CmdBuildRailroadStation().

void ResetStationClasses | ( |  | ) |

Reset station classes to their default state.

This includes initialising the Default and Waypoint classes with an empty entry, for standard stations and waypoints.

Definition at line 41 of file newgrf_station.cpp.

References StationClass::id, StationClass::name, StationClass::spec, STAT_CLASS_BEGIN, STAT_CLASS_MAX, and StationClass::stations.

Referenced by ResetNewGRFData().

void SetCustomStationSpec | ( | StationSpec * | statspec | ) |

Tie a station spec to its station class.

Parameters:

  | statspec | The station spec.

Definition at line 128 of file newgrf_station.cpp.

References ReallocT(), StationClass::spec, STAT_CLASS_MAX, and StationClass::stations.